import processing.core.*; import processing.video.*; import krister.Ess.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Boolean9 extends PApplet {// BOOLEAN v beta 0.9
// by Andy Doro & Tim Stutts & So Young Park
// 2006

// Now with BALLOONS!!! yes.
//
// Requirements: 
//   web camera
//   Ess library
//
// version 0.9 uses less taxing graphics and case statements to improve processing speed
//
// --------------------------------------------            LIBRARIES

 
 // loads ess library ( download this from http://www.tree-axis.com/Ess/ )

// --------------------------------------------            AUDIO


float[] blackRatio = new float[12];    // ratio of black pixels to total number

// ARRAY SOUND

//AudioChannel[] SineChannel = new AudioChannel[12];
AudioChannel[] TriangleChannel = new AudioChannel[12];
AudioChannel[] SquareChannel = new AudioChannel[12];

//SineWave[] mySineWave = new SineWave[12];
TriangleWave[] myTriangleWave = new TriangleWave[12];
SquareWave[] mySquareWave = new SquareWave[12];

AudioChannel[] PopChannel = new AudioChannel[12];

float Pitches[] = {
  1174.64f, 1046.52f, 987.76f, 880.0f, 784.0f, 659.26f, 523.26f, 440.0f, 293.66f, 261.63f, 246.94f, 220.0f };


// --------------------------------------------            VIDEO

Capture myCapture; 


int[] BoxValues = new int[12];  // array stores black pixel count of every box

int colWt = 45;
int rowHt = 40;

int coordX, coordY; //, colCount, rowCount, totalPicsBox;

// ---------------------  BALLOON STUFF

int numBalloons = 192;            // number of balloons

Balloon[] theBalloons = new Balloon[numBalloons];

float[] balloonRatio = new float[12];        //    current balloon size over max size. sets amplitude

PImage pop;

public void setup() 
{
  size(720,480);
  frameRate(15);

  noStroke();
  smooth();
  fill(255,80);

  coordX = 0;

  for (int x=0; x<16; x++) {
    for (int y=0; y<12; y++) {
      theBalloons[y+(x*12)] = new Balloon(x*colWt, y*rowHt);
    }
  }

  pop = loadImage("popp.gif");

  println(Capture.list());

  myCapture = new Capture(this, "IIDC FireWire Video", 720, 480, 15);  


  // -------- SOUND

  Ess.start(this);

  for(int i=0; i < 12; i++) {  // TriangleWave Oscillators
    myTriangleWave[i]=new TriangleWave(Pitches[i],.5f);
    TriangleChannel[i] = new AudioChannel();
    TriangleChannel[i].initChannel(TriangleChannel[i].frames(2000));
    myTriangleWave[i].generate(TriangleChannel[i]);   
    TriangleChannel[i].volume(0.0f);                        // eliminate annoying startup noise!
    TriangleChannel[i].play(Ess.FOREVER);
  }
  for(int i=0; i < 12; i++) {  // SquareWave Oscillators
    mySquareWave[i]=new SquareWave(Pitches[i],.5f);
    SquareChannel[i] = new AudioChannel();
    SquareChannel[i].initChannel(SquareChannel[i].frames(2000));
    mySquareWave[i].generate(SquareChannel[i]);    
    SquareChannel[i].volume(0.0f);                        // eliminate annoying startup noise! 
    SquareChannel[i].play(Ess.FOREVER);
  }

  for(int i=0; i < 12; i++) {                            // PopSamples. thanks Plaid!
    PopChannel[i] = new AudioChannel((12-i)+".wav");

  }



}


public void captureEvent(Capture myCapture) 
{ 
  // Read the captured frame
  myCapture.read(); 
} 

public void draw() 
{


  image(myCapture, 0, 0); 
  filter(THRESHOLD); 

  for (int coordY = 0; coordY < 12; coordY++)
  {
    PImage boxImage = get(coordX*colWt, coordY*rowHt, colWt, rowHt); // grab subimage of the box
    loadPixels();


    for (int i = 0; i < colWt*rowHt; i++) 
    {
      if (boxImage.pixels[i] == color(0))        // do our check to see if each pixel is black
      {                                          
        BoxValues[coordY] += 1;                 // if so, increase number in the array
      }  
    }

    blackRatio[coordY] = (float)BoxValues[coordY] / 1800; // gets black pic count ratio

    theBalloons[coordY+(12*coordX)].BalloonValue += 3*blackRatio[coordY];        // increase Balloon values in that column
    theBalloons[coordY+(12*coordX)].checkBalloon();                               // check if the Balloon value exceeds maxValue, if so then pop.  

    balloonRatio[coordY] = (theBalloons[coordY+(12*coordX)].BalloonValue) / 34.0f;  //  balloon size ratio to use for amplitude

  }    


  // ---------------------- APPLY AMPLITUDES & PLAY SAMPLES

  for(int i=0; i < 12; i++) {

    switch(theBalloons[i+(12*coordX)].colorValue) {
    case 0:
      TriangleChannel[i].volume(0.0f); // amplitude of trianglewave
      SquareChannel[i].volume(0.0f); // amplitude of squarewave
      break;
    case 1: 
      // SineChannel[i].volume(0.0); // amplitude of sinewave
      TriangleChannel[i].volume(balloonRatio[i]*0.25f); // amplitude of trianglewave
      SquareChannel[i].volume(0.0f); // amplitude of squarewave
      break;
    case 2:
      // SineChannel[i].volume(0.0); // amplitude of sinewave
      TriangleChannel[i].volume(0.0f); // amplitude of trianglewave
      SquareChannel[i].volume(balloonRatio[i]*0.25f); // amplitude of squarewave, dampered because andy doesn't like it
      break;
    }
    
    if (theBalloons[i+(12*coordX)].popValue == 1) {    // if balloon pops play sample
      // println(i + " popped");
      PopChannel[i].play(1);
    }

  }

  // ------------ VISUALS

  rectMode(CORNER);
  noStroke();
  fill(255,80);
  rect(0,0,width,height);           // draw big white translucent rect over whole image 


  //strokeWeight(2);
  //stroke(255,255,0);
  noStroke();
  fill(255,60);
  //noFill();
  rect((coordX*colWt), 0, colWt, height); // draw the jumping rectangle

  //noStroke();             // no outline of balloons

  // draw balloons
  for (int i=0; i < numBalloons; i++) {              
    theBalloons[i].drawBalloon();
  }

  coordX++;                         // increment coordX to jump to next column for next run-through
  coordX = coordX % 16;              // but modulo 16


    // ------------------------- reset values
  for (int i = 0; i < BoxValues.length; i++)    // reset boxvalues to zero
  {
    BoxValues[i] = 0;  
  }

}

public void mousePressed(){
  Ess.masterMute(!Ess.masterMute); // clicking anywhere causes program to mute
}

public void stop() {
  Ess.stop();
  super.stop();
}

//   --- ends ----


class Balloon
{
  int xpos;
  int ypos;
  float h;

  float BalloonValue;
  float maxValue = 34.0f;
  float minValue = 5.0f;

  float concentric;     // 3D effects
  float offset;

  int colorValue;     // which color is it
  int Alpha;

  int popValue;       // is it popped?

  Balloon (int _xpos, int _ypos)
  { 
    xpos = _xpos + 22;               
    ypos = _ypos + 20;

    h = random(2*PI);            // bob starts at random point in cycle
    BalloonValue = minValue;      

    colorValue = 0;      // start teal
    Alpha = 160;         
    popValue = 0;        // not popped

  }

  public void drawBalloon()
  {
    h += 0.2f;                // speed of the bob
    concentric = 1.0f;        // affects concentric ellipse to create fake 3D effect

    switch(popValue) {
    case 0:                       // if unpopped, draw balloon

      for (int i = 0; i < 10; i++ ) {   // Balloon Tint  

        switch(colorValue) {
        case 0:
          fill(35+(i*22),155+(i*10),135+(i*12),Alpha);
          break;
        case 1:
          fill(255, 75+(i*18),175+(i*8),Alpha);
          break;
        case 2:
          fill(255,155+(i*10),75+(i*18),Alpha);
          break;
        }
        offset = BalloonValue/(20*concentric);
        ellipse(xpos-offset, (ypos+(2*sin(h)))-offset, BalloonValue*concentric, (BalloonValue*1.2f)*concentric);
        concentric = (concentric*0.85f)+0.01f;
      }
      break;
    case 1:                                 // if it's popped,
      image (pop,xpos-10,ypos-10,20,20);                      // draw the explosion image
      popValue = 0;                                           // and unpop
      break;
    }
  }
  public void checkBalloon()
  {
    if (BalloonValue > maxValue) {                     // if it's too big, pop
      pop();
    }
  }

  public void pop()
  {    
    BalloonValue = minValue;            // reset to starting size
    colorValue++;                         // go to next color 
    colorValue = colorValue % 3;                //  hit end go back. mod to restart color cycle.
    popValue = 1;                        // says "it's popped"
  }
}

static public void main(String args[]) {   PApplet.main(new String[] { "Boolean9" });}}